import sys
#sys.path.append('/c/Users/lippert/Projects/limix/python/utils/')
sys.path.append('c:\\Users\\lippert\\Projects\\limix\\python\\utils')

from fastlmm import *

gawpath = 'c:\Users\lippert\Projects\gaw14'

if 1:#thin out SNPs
    pheno_file = os.path.join(gawpath , 'all.pheno')
    snps_file = os.path.join(gawpath , 'all')
    out_path = ('.\out_gaw14')

if 1:
    opt =[
        '--out',
        out_path,
        '--bfile',
        snps_file,
        '--bfilesim',
        snps_file,
        '--pheno',
        pheno_file,
        '--exclude_distance',
        '2.0'
        ]

if __name__ == '__main__':
    (options, args) = get_options(opt)
    recompute =  ('recompute' in sys.argv)

    if 'linreg' in sys.argv:
        command_linreg = run_linreg(pheno_file = options.pheno_file, file_test=options.file_test, bfile_test = options.bfile_test, tfile_test = options.tfile_test, out_dir=options.out_dir, covariates = options.covariates, chr_only = options.chr_only, testing = False, quiet = False,recompute = recompute)
    if 'full' in sys.argv:#no exclusion
        out = os.path.join(options.out_dir,'noexcl')
        command_LMM = run_fastlmm(pheno_file = options.pheno_file,file_test=options.file_test,bfile_test = options.bfile_test,tfile_test = options.tfile_test,bfile_sim = options.bfile_sim,file_sim = options.file_sim,tfile_sim= options.tfile_sim, out_dir=out, covariates = options.covariates, excl_dist = None, excl_pos = options.excl_pos, chr_only = options.chr_only, testing = False, quiet = False, N=None,refit_delta = False,recompute= recompute)#started 11.15am
    
    if 'exclusion' in sys.argv:#with exclusion
        out = os.path.join(options.out_dir,'excl')
        command_LMM = run_fastlmm(pheno_file = options.pheno_file,file_test=options.file_test,bfile_test = options.bfile_test,tfile_test = options.tfile_test,bfile_sim = options.bfile_sim,file_sim = options.file_sim,tfile_sim= options.tfile_sim, out_dir=options.out_dir, covariates = options.covariates, excl_dist = options.excl_dist, excl_pos = options.excl_pos, chr_only = options.chr_only, testing = False, quiet = False, N=None,refit_delta = False,recompute=recompute)#started 11.15am    
    
    if 'select' in sys.argv:#fastlmm select
        linreg_out = os.path.join(out_path, 'results_linreg.txt')
        
        Nsnps0,lambdas0 = run_select_topN(pheno_file= options.pheno_file, linreg_out=linreg_out,file_test=options.file_test,bfile_test = options.bfile_test,tfile_test = options.tfile_test,bfile_sim = options.bfile_sim,file_sim = options.file_sim, tfile_sim = options.tfile_sim, out_dir=options.out_dir, covariates = options.covariates, excl_dist = options.excl_dist, excl_pos = options.excl_pos, chr_only = options.chr_only, quiet = False, refit_delta = False, command=None, Nmin=0, Nmax=30, increment=1,recompute=recompute)

        #Nsnps1,lambdas1 = run_select_topN(pheno_file= options.pheno_file, linreg_out=linreg_out,file_test=options.file_test,bfile_test = options.bfile_test,tfile_test = options.tfile_test,bfile_sim = options.bfile_sim,file_sim = options.file_sim, tfile_sim = options.tfile_sim, out_dir=options.out_dir, covariates = options.covariates, excl_dist = options.excl_dist, excl_pos = options.excl_pos, chr_only = options.chr_only, quiet = False, refit_delta = False, command=None, Nmin=80, Nmax=110, increment=3)
        Nsnps1 = []
        lambdas1 = []
        nsnps = np.hstack([Nsnps0,Nsnps1])
        lambdas = np.hstack([lambdas0,lambdas1])
    
        order = nsnps.argsort()
        lambdas = lambdas[order]
        nsnps = nsnps[order]
        plt.interactive(1)
        plt.plot(nsnps,lambdas)
        plt.ylabel('lambda')
        plt.xlabel'number SNPs'
    
