import pylab as PL

plparams = {'backend': 'ps',
          'axes.labelsize': 15,
          'text.fontsize': 15,
          'title.fontsize': 15,
          'legend.fontsize': 15,
          'xtick.labelsize': 15,
          'ytick.labelsize': 15,
          'text.usetex': False}
PL.rcParams.update(plparams)


def imagesc(X,colormap=None,aspect = 'auto'):
    if(colormap==None):
        colormap = PL.cm.gray
    PL.imshow(X,aspect=aspect,interpolation='nearest',cmap=colormap) #aspect='auto' is the alternative

