import sys
import cPickle
import os
#add limix path
#limix
import platform

#use is this as I am running code on linux and MAC.
#I have two compiled instances of limix around..
sys.path.append('./../lib/limix/python')
sys.path.append('./../lib')
if len(platform.mac_ver()[0])>0:
    sys.path.append('./../lib/limix/build_mac/src/interfaces/python')
else:
    sys.path.append('./../lib/limix/build_linux/src/interfaces/python')

import data
from plot import *
    
#import main limix module
import limix
from utils.util import *
import utils.fdr as fdr
#import preprocessing utils
import utils.preprocess as preprocess


#pythong plotting and numerical tools
import scipy as SP
import pylab as PL
import h5py
import pdb
import scipy.stats as st



if __name__ == '__main__':
 
    from pyplot import *
    PL.ion()
    
    pheno_names = ['5_FT10']
 
    cache_file = './demo_cacheFT.pickle'
    #1. load GWAS data
    if not os.path.exists(cache_file) or 'recalc' in sys.argv:
        #1. load data
        data = data.load_arab107(pheno_names)
        cPickle.dump(data,open(cache_file,'wb'),-1)
    else:
        data= cPickle.load(open(cache_file,'rb'))
        globals().update(data)



    if 1:
        y = data['Pheno']
        y -= y.min() - 1E-1
        y_ = st.boxcox(y)[0]
        PL.figure(figsize=[12,5])
        PL.subplot(121)
        PL.hist(y,12)
        PL.xlabel('Raw FT')
        PL.subplot(122)
        PL.hist(y_,12)
        PL.xlabel('Box Cox FT')
        PL.savefig('./raw_box_cox_ft.pdf')
    
